<?php
if (!defined('_CAN_LOAD_FILES_'))
	exit;
class AddThisTwitter extends Module{
	
	private $tbl_styles = array(
		0 => "No style",
		1 => "Style 1",
		2 => "Style 2",
		3 => "Style 3",
		4 => "Style 4",
		5 => "Style 5",
		6 => "Style 6"
	);
	
	public function __construct(){
		$this->name = 'addthistwitter';
		$this->tab = 'add_this_twitter';
		$this->version = '1.0';
		$this->author = 'MICHAEL D.';
		$this->module_key = "a12272e6faea2ca9981500a74fe22863";
		parent::__construct();
		$this->displayName = $this->l('AddThis Twitter');
		$this->description = $this->l('Add an addThis block with twitter');
  		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
	}
	public function install(){
		if (
			!parent::install() OR
			!$this->registerHook('top') OR
			!$this->registerHook('footer') OR
			!$this->registerHook('productfooter') OR
			!$this->registerHook('leftcolumn') OR
			!$this->registerHook('centercolumn') OR
			!$this->registerHook('rightcolumn') OR
			// Temporary hooks. Do NOT hook any module on it. Some CRUD hook will replace them as soon as possible.
			!$this->registerHook('categoryAddition') OR
			!$this->registerHook('categoryUpdate') OR
			!$this->registerHook('categoryDeletion') OR
			!$this->registerHook('afterSaveAdminMeta') OR
			!Configuration::updateValue('ADDTHIS_TWITTER_TOP', 0) OR 
			!Configuration::updateValue('ADDTHIS_TWITTER_FOOTER', 0) OR 
			!Configuration::updateValue('ADDTHIS_TWITTER_PRODUCTFOOTER', 0) OR 
			!Configuration::updateValue('ADDTHIS_TWITTER_LEFTCOLUMN', 0) OR 
			!Configuration::updateValue('ADDTHIS_TWITTER_CENTERCOLUMN', 0) OR 
			!Configuration::updateValue('ADDTHIS_TWITTER_RIGHTCOLUMN', 0) OR 
//			!Configuration::updateValue('ADDTHIS_TWITTER_USERNAME', 'michaeldumontet') OR
			!Configuration::updateValue('ADDTHIS_TWITTER_TEXT', 'Slogan here') OR
			!Configuration::updateValue('ADDTHIS_TWITTER_HASHTAGS', 'Company')
		){
			return false;
		}
		return true;
	}
	public function uninstall(){
		if (
			!parent::uninstall() OR
			!Configuration::deleteByName('ADDTHIS_TWITTER_TOP') OR
			!Configuration::deleteByName('ADDTHIS_TWITTER_FOOTER') OR
			!Configuration::deleteByName('ADDTHIS_TWITTER_PRODUCTFOOTER') OR
			!Configuration::deleteByName('ADDTHIS_TWITTER_LEFTCOLUMN') OR
			!Configuration::deleteByName('ADDTHIS_TWITTER_CENTERCOLUMN') OR
			!Configuration::deleteByName('ADDTHIS_TWITTER_RIGHTCOLUMN') OR
			!Configuration::deleteByName('ADDTHIS_TWITTER_USERNAME') OR
			!Configuration::deleteByName('ADDTHIS_TWITTER_TEXT') OR
			!Configuration::deleteByName('ADDTHIS_TWITTER_HASHTAGS')
		){
			return false;
		}
		return true;
	}
	
	public function getContent(){
		$output = '<h2>'.$this->displayName.'</h2>';
		if (Tools::isSubmit('submitBlockAddThis')){
			// recup infos formulaire
			$formStyleChooseHookTop				= Tools::getValue('formStyleChooseHookTop');
			$formStyleChooseHookFooter			= Tools::getValue('formStyleChooseHookFooter');
			$formStyleChooseHookProductFooter	= Tools::getValue('formStyleChooseHookProductFooter');
			$formStyleChooseHookLeftColumn		= Tools::getValue('formStyleChooseHookLeftColumn');
			$formStyleChooseHookCenterColumn	= Tools::getValue('formStyleChooseHookCenterColumn');
			$formStyleChooseHookRightColumn		= Tools::getValue('formStyleChooseHookRightColumn');
			$formTwitterUsername				= Tools::getValue('formTwitterUsername');
			$formTwitterText					= Tools::getValue('formTwitterText');
			$formTwitterHashtags				= Tools::getValue('formTwitterHashtags');
				
			// verif
			if(
				$formStyleChooseHookTop < 0				||
				$formStyleChooseHookFooter < 0			||
				$formStyleChooseHookProductFooter < 0	||
				$formStyleChooseHookLeftColumn < 0		||
				$formStyleChooseHookCenterColumn < 0	||
				$formStyleChooseHookRightColumn < 0		
			){
				$output .= $this->displayError($this->l('Style not positive'));
				
			}else{
				Configuration::updateValue('ADDTHIS_TWITTER_TOP', (int)($formStyleChooseHookTop));
				Configuration::updateValue('ADDTHIS_TWITTER_FOOTER', (int)($formStyleChooseHookFooter));
				Configuration::updateValue('ADDTHIS_TWITTER_PRODUCTFOOTER', (int)($formStyleChooseHookProductFooter));
				Configuration::updateValue('ADDTHIS_TWITTER_LEFTCOLUMN', (int)($formStyleChooseHookLeftColumn));
				Configuration::updateValue('ADDTHIS_TWITTER_CENTERCOLUMN', (int)($formStyleChooseHookCenterColumn));
				Configuration::updateValue('ADDTHIS_TWITTER_RIGHTCOLUMN', (int)($formStyleChooseHookRightColumn));
				Configuration::updateValue('ADDTHIS_TWITTER_USERNAME', $formTwitterUsername);
				Configuration::updateValue('ADDTHIS_TWITTER_TEXT', $formTwitterText);
				Configuration::updateValue('ADDTHIS_TWITTER_HASHTAGS', $formTwitterHashtags);
				
				$this->_clearAddthisCache();
				
				$output .= $this->displayConfirmation($this->l('Settings updated...'));
			}
		}
		return $output.$this->displayForm();
	}
	
	/**
	 * 
	 * Formulaire
	 */
	public function displayForm(){
		$liste = '
		<fieldset>
			<legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Style').'</legend>';
			foreach( $this->tbl_styles as $k => $v ){
				if( $k != 0 ){
					$liste .= 'Style '.$k.' <img src="'.$this->_path.'images/style'.$k.'.png" alt="style '.$k.'" title="style '.$k.'" />';
					
					if( $k == 3 ){
						$liste .= '@xxx #xxx';
					}elseif( $k == 4 ){
						$liste .= $this->l('Your twitter text').' #xxx';
					}
					
					$liste .= '<br />';
				}
			}
		$liste .= '
		</fieldset>';
		
		$form = '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
			<fieldset>
				<legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Settings').'</legend>
				
				<label>'.$this->l('Your twitter username').'</label>
				<div class="margin-form">
					@<input type="text" name="formTwitterUsername" value="'.Configuration::get('ADDTHIS_TWITTER_USERNAME').'" placeholder="'.$this->l('Your twitter username').'" />
					<p class="clear">'.$this->l('Enter here, your twitter username. It use for style 3, 5 and 6').'</p>
				</div>
				
				<label>'.$this->l('Hashtags').'</label>
				<div class="margin-form">
					<input type="text" name="formTwitterHashtags" value="'.Configuration::get('ADDTHIS_TWITTER_HASHTAGS').'" placeholder="'.$this->l('Your twitter hashtags').'" />
					<p class="clear">'.$this->l('Enter here, your twitter hashtags. It use for style 3 and 4').'</p>
				</div>
				
				<label>'.$this->l('Your twitter text').'</label>
				<div class="margin-form">
					<input type="text" name="formTwitterText" value="'.Configuration::get('ADDTHIS_TWITTER_TEXT').'" placeholder="'.$this->l('Your twitter text').'" />
					<p class="clear">'.$this->l('Enter here, your twitter text. It use for style 4').'</p>
				</div>
				
				<label>'.$this->l('Style choose for zone top').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookTop">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('ADDTHIS_TWITTER_TOP') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<label>'.$this->l('Style choose for zone footer').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookFooter">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('ADDTHIS_TWITTER_FOOTER') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<label>'.$this->l('Style choose for zone product footer').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookProductFooter">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('ADDTHIS_TWITTER_PRODUCTFOOTER') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				
				
				
				<label>'.$this->l('Style choose for zone left column').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookLeftColumn">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('ADDTHIS_TWITTER_LEFTCOLUMN') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<label>'.$this->l('Style choose for zone center column').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookCenterColumn">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('ADDTHIS_TWITTER_CENTERCOLUMN') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<label>'.$this->l('Style choose for zone right column').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookRightColumn">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('ADDTHIS_TWITTER_RIGHTCOLUMN') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<center><input type="submit" name="submitBlockAddThis" value="'.$this->l('Save').'" class="button" /></center>
			</fieldset>
		</form>';
		
		return $liste.$form;
	}
	
	/**
	*
	* retourne le style addthis a afficher
	* @param int $style
	*/
	public function getTypeAddthis( $style ){
		global $smarty; 
		
		switch ($style){
			/*
			 * SOURCE : https://dev.twitter.com/docs/tweet-button#properties
			 * tw:via='username'
			 * tw:text='xxx'
			 * tw:hashtags='xxx'
			 */
			
			// Std
			case 1 :
				$s = '
				<a class="addthis_button_tweet"></a>
				';
				break;

			// Vertical Counter
			case 2 :
				$s = '
				<a class="addthis_button_tweet" tw:count="vertical"></a> 
				';
				break;
				
			// Standard with Customized Via
			case 3 :
				//echo $_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
				$s = '
				<a class="addthis_button_tweet" 
					tw:via="'.Configuration::get('ADDTHIS_TWITTER_USERNAME').'"
					tw:hashtags="'.Configuration::get('ADDTHIS_TWITTER_HASHTAGS').'"
				></a> 
				';
				break;
			
			// Standard with Customized Tweet Text
			case 4 :
				$s = '
				<a class="addthis_button_tweet" 
					tw:text="'.Configuration::get('ADDTHIS_TWITTER_TEXT').'"
					tw:hashtags="'.Configuration::get('ADDTHIS_TWITTER_HASHTAGS').'"	
				></a>
				';
				break;
			
			// Standard with Customized Related
			case 5 :
				$s = '
				<a class="addthis_button_tweet" 
					tw:related="'.Configuration::get('ADDTHIS_TWITTER_USERNAME').'"
				></a> 
				';
				break;

			// Twitter Follow Button
			case 6 :
				$s = '
				<a class="addthis_button_twitter_follow_native" addthis:userid="'.Configuration::get('ADDTHIS_TWITTER_USERNAME').'"></a>  
				';
				break;
				
			default :
				$s ='';
		}
		return "<!-- AddThis Button Twitter BEGIN --><div class='addthis_toolbox addthis_default_style'>".$s."</div><!-- AddThis Button Twitter END -->";
	}
	
	/**
	 * 
	 * hook top
	 * @param array $params
	 */
	public function hookTop($params){
		global $smarty, $cookie;
		//echo "Cookie: ".$cookie->__get('typesite');
		
		$id_customer = (int)($params['cookie']->id_customer);
		// Get all groups for this customer and concatenate them as a string: "1,2,3..."
		// It is necessary to keep the group query separate from the main select query because it is used for the cache
		$groups = $id_customer ? implode(', ', Customer::getGroupsStatic($id_customer)) : _PS_DEFAULT_CUSTOMER_GROUP_;
		$id_product = (int)(Tools::getValue('id_product', 0));
		$id_category = (int)(Tools::getValue('id_category', 0));
		$id_lang = (int)($params['cookie']->id_lang);
		$smartyCacheId = 'addthisgoogleplus|'.$groups.'_'.$id_lang.'_'.$id_product.'_'.$id_category;
		Tools::enableCache();
		if (!$this->isCached('addthis-top.tpl', $smartyCacheId)){
			// traitement ici
			//if (Tools::isSubmit('submitBlockAddThis')){}
		}
		$smarty->cache_lifetime = 31536000; // 1 Year

		$style = $this->getTypeAddthis( Configuration::get('ADDTHIS_TWITTER_TOP') );
		$smarty->assign('addthis_twitter_top', $style);
		$display = $this->display(__FILE__, 'addthis-top.tpl', $smartyCacheId);
		Tools::restoreCacheSettings();
		return $display;
	}
	
	/**
	 * 
	 * hook footer
	 * @param array $params
	 */
	public function hookFooter($params){
		global $smarty, $cookie;
		
		$style = $this->getTypeAddthis( Configuration::get('ADDTHIS_TWITTER_FOOTER') );
		$smarty->assign('addthis_twitter_footer', $style);
		$display = $this->display(__FILE__, 'addthis-footer.tpl');
		return $display;
	}
	
	/**
	 * 
	 * hook product footer
	 * @param array $params
	 */
	public function hookProductFooter($params){
		global $smarty, $cookie;

		$style = $this->getTypeAddthis( Configuration::get('ADDTHIS_TWITTER_PRODUCTFOOTER') );
		$smarty->assign('addthis_twitter_productfooter', $style);
		$display = $this->display(__FILE__, 'addthis-productfooter.tpl');
		return $display;
	}

	
	/**
	 *
	 * hook left column
	 * @param array $params
	 */
	public function hookLeftColumn($params){
		global $smarty, $cookie;
		
		$style = $this->getTypeAddthis( Configuration::get('ADDTHIS_TWITTER_LEFTCOLUMN') );
		$smarty->assign('addthis_twitter_leftcolumn', $style);
		$display = $this->display(__FILE__, 'addthis-leftcolumn.tpl');
		return $display;
	}
	
	/**
	 *
	 * hook center column
	 * @param array $params
	 */
	public function hookCenterColumn($params){
		global $smarty, $cookie;
		
		$style = $this->getTypeAddthis( Configuration::get('ADDTHIS_TWITTER_CENTERCOLUMN') );
		$smarty->assign('addthis_twitter_centercolumn', $style);
		$display = $this->display(__FILE__, 'addthis-centercolumn.tpl');
		return $display;
	}
	
	/**
	*
	* hook right column
	* @param array $params
	*/
	public function hookRightColumn($params){
		global $smarty, $cookie;
	
		$style = $this->getTypeAddthis( Configuration::get('ADDTHIS_TWITTER_RIGHTCOLUMN') );
		$smarty->assign('addthis_twitter_rightcolumn', $style);
		$display = $this->display(__FILE__, 'addthis-rightcolumn.tpl');
		return $display;
	}
	
	/**
	 * 
	 * vider le cache
	 */
	private function _clearAddthisCache(){
		$this->_clearCache('addthistwitter.tpl');
		Tools::restoreCacheSettings();
	}
	public function hookCategoryAddition($params){
		$this->_clearAddthisCache();
	}
	public function hookCategoryUpdate($params){
		$this->_clearAddthisCache();
	}
	public function hookCategoryDeletion($params){
		$this->_clearAddthisCache();
	}
	public function hookAfterSaveAdminMeta($params){
		$this->_clearAddthisCache();
	}
}